<?xml version="1.0" encoding="UTF-8"?>
<jube>
  <include-path>
  <path >/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/platforms/leonardo</path>
  <path >/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/workloads/qe/pw/ausurf</path>
  <path >/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/applications/qe/7.2/pw</path>
  <path >/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/scripts/tau</path>
  </include-path>

  <benchmark name="qe-ausurf" outpath="profile_tau">
    <comment>Quantum Espresso PWSCF benchmark v7.2</comment>    

    <!-- no. of nodes, tasks, etc -->
    <parameterset name="systemParameter" init_with="platform.xml">
    <parameter name="nodes" type="int" default="1">1,2</parameter>
    <parameter name="taskspernode" type="int" default="4">4</parameter>
    <parameter name="threadspertask">8</parameter>
    <parameter name="taskspersocket">2</parameter>
    <parameter name="ncores" type="int">32</parameter>
    <parameter name="accountno" >cin_staff</parameter>
    <parameter name="timelimit">01:00:00</parameter>
    <parameter name="gres" separator=";">gpu:$taskspernode</parameter>
    <parameter name="ready_file">ready</parameter>
    </parameterset>

    <parameterset name="applicationParameter" init_with="application.xml">
       <parameter name="install">QE7.2-AWARE,QE7.2-NOAWARE</parameter>
       <parameter name="bindir">/leonardo_work/Max3_devel_2/WP3/applications/q-e/$install/bin</parameter>
       <parameter name="executable"> $bindir/pw.x</parameter>
    </parameterset>

   <!-- running the job, llsubmit, runjob , etc -->
   <parameterset name="executeset" init_with="platform.xml">
      <parameter name="wrapname">tau-prof.sh</parameter>
      <parameter name="modules">module load profile/chem-phys quantum-espresso/7.2--openmpi--4.1.4--nvhpc--23.1-openblas-cuda-11.8 nvhpc </parameter>
    </parameterset>

    <!-- testcase parameters -->
    <parameterset name="testcaseset" init_with="workload.xml">
      <parameter name="maxstep">100</parameter>
    </parameterset>

    <!-- profiling wrapper parameters -->
    <parameterset name="profilingset" init_with="script.xml">
    </parameterset>

    <substituteset name="profilingsub" init_with="script.xml">
    </substituteset>

     <substituteset name="inputsub" init_with="workload.xml">
    </substituteset>

    <!-- files needed incl job file and input files -->
    <fileset name="jobfiles" init_with="platform.xml">
      <copy>/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/workloads/qe/pw/$dirin/*</copy>
      <copy>/leonardo_work/Max3_devel_2/WP3/JUBE4MaX/max-inputs/scripts/tau/tau-prof.sh</copy>
    </fileset>

    <!-- Substitute jobfile -->
    <substituteset name="executesub" init_with="platform.xml">
    <sub source="#ACCOUNT_NO#" dest="$accountno" />
    <sub source="#READY#" dest="$ready_file" />
    </substituteset>

    <patternset name="pattern">
	    <pattern name="mpi_waitall" type="float">\s+${jube_pat_nfp}\s+${jube_pat_int}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint} MPI_Waitall()</pattern>
	    <pattern name="mpi_allreduce" type="float">\s+${jube_pat_nfp}\s+${jube_pat_int}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint} MPI_Allreduce()</pattern>
	    <pattern name="mpi_barrier" type="float">\s+${jube_pat_nfp}\s+${jube_pat_int}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint}\s+${jube_pat_nint} MPI_Barrier()</pattern>
    </patternset>

    <!-- Operation -->
    <step name="submit" suffix="N${nodes}_$install" >
      <use>testcaseset</use>
      <use>systemParameter</use>
      <use>applicationParameter</use>
      <use>executeset</use>
      <use>executesub</use>
      <use>inputsub</use>
      <use>jobfiles</use>
      <use>profilingset</use>
      <use>profilingsub</use>
      <do>export PATH=$PATH:$path/bin</do>
      <do>export TAU_COMM_MATRIX=1</do>
      <do done_file="$ready_file" tag="!test">$submit $submit_script</do> <!-- actual submission directive -->
      <do>pprof -m -s > summary.out</do>
      <do>sed -i 's/,//g' summary.out</do>
      <do>rm -r ./out</do>
    </step>    

    <analyser name="analyse" reduce="true">
      <use>pattern</use>
      <analyse step="submit">
        <file>summary.out</file>
      </analyse>
    </analyser>

    <result>
      <use>analyse</use>
      <table name="result" style="csv" sort="nodes" >
        <column title="Nodes">nodes</column>
        <column title="Tasks/Node">taskspernode</column>
        <column title="Install">install</column>
	<column format=".2f" title="mpi_waitall (ms)">mpi_waitall</column>
        <column format=".2f" title="mpi_allreduce (ms)">mpi_allreduce</column>
        <column format=".2f" title="mpi_barrier (ms)">mpi_barrier</column>
      </table>
   </result>

  </benchmark>
</jube>
